package MyCounterPackage;

import javacard.framework.*;

public class MyCounterApplication extends Applet {

    // Data variable to store the loyalty points
    short CounterValue = 49;
    final static short CounterValueLimit = (short)32767;

    // MyCounterApplication commands
    final static byte CLA = (byte)0xB0;
    final static byte INS_RESET = (byte)0xE0;
    final static byte INS_READ = (byte)0xE1;
    final static byte INS_INCREASE = (byte)0xE2;
    final static byte INS_DECREASE = (byte)0xE3;

    // Applet's ERROR Status Words
    final static short SW_CLANOTSUPPORTED = (short)0xF0C0;
    final static short SW_INSNOTSUPPORTED = (short)0xF0C1;
    final static short SW_LCNOTSUPPORTED = (short)0xF0C2;
    final static short SW_INCEXCEEDS = (short)0xF0C3;
    final static short SW_DECEXCEEDS = (short)0xF0C4;
    final static short SW_INVALID = (short)0xF0C5;
    final static short SW_UNDEFINED = (short)0xF0C6;

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        new MyCounterApplication();
    }

    protected MyCounterApplication() {
        register();
    }

    public void process(APDU apdu) {
    byte[] apduBuffer = apdu.getBuffer();
	short temporaryShortValue = 0;

	// Return if the APDU is selection APDU
	if(selectingApplet()){
			return;
		}

	// For Command APDUs check their CLA value
	if(apduBuffer[ISO7816.OFFSET_CLA]!= CLA){
		ISOException.throwIt(SW_CLANOTSUPPORTED);}

	// For Command APDUs check their INS value
	if (apduBuffer[ISO7816.OFFSET_INS] == INS_RESET){
	    CounterValue = 0;
	    return;
	}

	if (apduBuffer[ISO7816.OFFSET_INS] ==INS_READ){
	    converterShortToByte(apduBuffer);
	    apdu.setOutgoingAndSend((short)0, (short)2);
	    return;
	}


	if (apduBuffer[ISO7816.OFFSET_INS] ==INS_INCREASE){
	    if(apduBuffer[ISO7816.OFFSET_LC]==(byte)0x02){
		temporaryShortValue = converterByteToShort(apduBuffer,  ISO7816.OFFSET_CDATA);
		 	if(temporaryShortValue < (short)(CounterValueLimit-CounterValue)){
			    CounterValue = (short)(CounterValue+temporaryShortValue);
			    return;
			}else{
			    ISOException.throwIt(SW_INCEXCEEDS);}
	    }else{
		ISOException.throwIt(SW_LCNOTSUPPORTED);}
	}

	if (apduBuffer[ISO7816.OFFSET_INS] ==INS_DECREASE){
	    if(apduBuffer[ISO7816.OFFSET_LC]==(byte)0x02){
		temporaryShortValue = converterByteToShort(apduBuffer, ISO7816.OFFSET_CDATA);
			if(temporaryShortValue < CounterValue){
			  CounterValue = (short)(CounterValue - temporaryShortValue);
			    return;
			}else{
			    ISOException.throwIt(SW_DECEXCEEDS);}
	    }else{
		ISOException.throwIt(SW_LCNOTSUPPORTED);}
	}else{
	    ISOException.throwIt(SW_INSNOTSUPPORTED);}
	return;
    }

    private void converterShortToByte(byte[] inputArray){
	inputArray[0] = (byte) ((short)(CounterValue & (short)0xFF00) >> (short)0x0008);
	inputArray[1] = (byte) (CounterValue & (short)0x00FF);

    }

    private short converterByteToShort(byte[] inputArray, short arrayOffset){
	return (short) (((inputArray[arrayOffset] << 8)) | ((inputArray[(short)(arrayOffset+(short)1)] & 0xff)));
    }

}
